;### uK4 - ドメインの管理共通
;# $key4 は対象ドメイン、$key5 はユーザ/リスト/エイリアス
use utf8;
$dhome = 'domain_home.cgi';				# トップ
$duser = 'domain_user.cgi';				# ユーザの管理トップ、ユーザの追加
$duseredit = 'domain_user_edit.cgi';	# ユーザの管理、編集
$duserdel = 'domain_user_del.cgi';		# ユーザの削除
$dusermsg = 'domain_user_msg.cgi';		# ユーザログインメッセージの編集
$dlist = 'domain_list.cgi';				# リストの管理トップ、リストの追加
$dlistedit = 'domain_list_edit.cgi';	# リストの管理、編集
$dlistdel = 'domain_list_del.cgi';		# リストの削除
$dsel = 'domain_select.cgi';			# 振り分け用
$dsmail = 'domain_smail.cgi';			# メッセージ送信用
$dalias = 'domain_alias.cgi';			# エイリアスの管理
$daddress = 'domain_addresslist.cgi';	# 共用アドレス帳の管理
$dlog = 'domain_log.cgi';				# ログの管理
$dmenu = 'domain_extmenu.cgi';			# 追加メニューの管理
$maxmenu = 15;							# 追加メニュー制限
$ttl = $ttl*2;							# 有効時間は2倍
$wsize = ",320,200";					# 小ウインドウのサイズ
@k4arraym = qw(Attachment Deny Footer ForceFrom GoodbyeMessage Header ListAdmin Log MaxUser MessageID 
	MessageSize Owner ReplyTo Robot RobotConfirm RobotHelp RobotInfo RobotTTL Subscribe Tag WelcomeMessage);
@xmailarraym = qw(RealName CompanyName ClosedML ListSender ReceiveEnable UseReplyTo);
$helper = 'helper.cgi';					# ヘルプ表示用スクリプト
$na = $nofilter if -f "$tempdir/$nf";
&auth();

## ドメイン/ユーザ/リストなどの情報を得る
sub check_domaininfo {
	local($a1,$a2,$a3,$a4,$a5,$tmp,$tmp0,@reg,@tmp);
	local($domain) = @_;
	undef $aliasdomain;
	$usertotal = $listtotal = 0;
	@usertotal=(); @listtotal=(); @aliastotal=();
	local ($tmp,$postmaster1,$robot1) = ($domain,$postmaster,$robot);
	foreach(qw(tmp postmaster1 robot1)){$$_ =~ s/[.\-\@]/\\$&/g;}
	
	# ユーザ/リストを調査
	open(MyFILE3,"$mailroot/mailusers.tab") || return();
		while (<MyFILE3>){
			chomp;
			s/"//g;
			@reg = split(/[\t ]+/,$_);
			if ($reg[0] =~ /^$tmp$/i){
				$tmp0 = "$reg[1]\@$reg[0]";
				next if $tmp0 =~ /^($postmaster1|$robot1)$/i;	# ポストマスターとリストプロセッサはカウントしない
				if ($reg[5] =~ /^U$/i){
					next if $robot =~ /^$reg[1]\@$reg[0]$/i;
					push(@usertotal,"$reg[1]\@$reg[0]");
					$usertotal++;
					next;
				}
				if ($reg[5] =~ /^M$/i){
					push(@listtotal,"$reg[1]\@$reg[0]");
					$listtotal++;
					next;
				}
			}
		}
	close(MyFILE3);
	
	# エイリアスを調査
	if (open(MyFILE3,"$mailroot/aliases.tab")){
			while (<MyFILE3>){
				chomp;
				if (/^"*$tmp"*\t/){push(@aliastotal,"$_\n");}
				else {push(@aliasall,"$_\n");}
			}
		close(MyFILE3);
	}
	
#	@aliastotal = sort(@aliastotal);
	@listtotal = sort(@listtotal);
	@usertotal = sort(@usertotal);
	
	# ドメインエイリアスを調査
	if (open(MyFILE3,"$mailroot/aliasdomain.tab")){
			while (<MyFILE3>){
				chomp;
				s/"//g;
				($a1,$a2) = split(/\t+/,$_);
				$a1 =~ s/\*/\.*/g;
				$msg_d = "このドメインは $a2 ドメインのエイリアスです。"
					if ($domain =~ /^$a1$/i && $domain !~ /^$a2$/i && !-d "$mailroot/domains/$domain");
			}
		close(MyFILE3);
	}
	
	# 対象ドメインの環境設定を得る
	if (open(MyFILE3,"$mailroot/domainadmin.tab")){
			while (<MyFILE3>){
				chomp;
				s/"//g;
				if (/^&* *($tmp\t.+)/){
					($a1,$a2,$maxuser,$maxlist,$maxalias,$MaxMBSize,$SmtpPerms,$maxlistmember,$maxlistmsgsize)
						= split(/\t/,$1);
				}
			}
		close(MyFILE3);
	}
	if (!$MaxMBSize){$MaxMBSize = $maxmbsize;}
	if (!$SmtpPerms){$SmtpPerms = 'MRZ';}
	if (!$maxlistmember){$maxlistmember = 10;}		# 旧ver対策
	if (!$maxlistmsgsize){$maxlistmsgsize = 100;}	#  〃
	
	# 表示のために
	foreach('alias','list','user'){
		undef ${$_ . 'total'};
		undef ${'select_' . $_};
		if (${'max' . $_} eq '' || ${'max' . $_} == 0){${'max' . $_} = '0';}
		else {${'max' . $_ . 1} = '/max:'. ${'max' . $_};}
		if (@{$_ . 'total'}){${$_ . 'total'} = $#{$_ . 'total'} + 1;} else {${$_ . 'total'} = 0;}
		${$_ . 'total1'} = " (現在の登録数: <b>${$_ . 'total'}</b>${'max' . $_ . 1})";
		foreach $i (@{$_ . 'total'}){
			@tmp = split(/@/,"$i");
			${'select_' . $_} .= "<option value='$tmp[0]'>$tmp[0]</option>";
		}
		${'select_' . $_} =~ s/(<option +value='$tuser')(>$tuser<)/$1 selected$2/i;
	}
}

## 入力リスト情報をチェック
sub check_listinput {
	if ($UseReplyTo == 2){
		&thml("返信アドレスが変です！",1) if ($ReplyTo && $ReplyTo !~ /^$emreg1$/);
		$UseReplyTo = 0;
	} else {$ReplyTo = '';}
	if ($ForceFrom){
		my $tmp = $ForceFrom;
		$tmp =~ s/ *\(.+\) *//g;
		$tmp = $1 if $tmp =~ /<(.+)>/;
		&html("From:アドレスが変です！") if $tmp !~ /^$emreg$/;
	}
	&html("返送アドレスが変です！") if ($ListSender && $ListSender !~ /^$emreg1$/);
	&html("メッセージサイズ制限は数値を指定してください！") if $MessageSize =~ /[^\d]/;
	&html("メッセージのFrom:アドレスが変です！") if ($ListAdmin && $ListAdmin !~ /^$emreg1$/);
	&html("自動処理の通知先アドレスが変です！") if ($Owner && $Owner !~ /^$emreg1$/);
	&html("自動登録の定員は数値を指定してください！") if $MaxUser =~ /[^\d]/;
	&html("自動登録の定員は最大 $maxlistmember 人です！") if $MaxUser > $maxlistmember;
	&html("[リスト管理] 最大メンバー数は数値を指定してください！") if ($Ladmin && $Lmember =~ /[^\d]/);
	&html("[リスト管理] 最大メンバー数は $maxlistmember 人です！") if ($Ladmin && $Lmember > $maxlistmember);
}

## 管理用メモを得る
sub check_memo {
	local($domain,$user) = @_;
	undef $memo;
	open(MyFILE3,"$mailroot/domains/$domain/$user/$xmailcfg/memo.tab") || return();
		while(<MyFILE3>){
			$_ = &dec_utf($_);		# guess機能を利用
			chomp;
			$memo .= "$_\n";
		}
	close(MyFILE3);
	$memo =~ s/^\n+//;
	$memo =~ s/\s+$/\n/;
	&htmlconv('memo');
}

## 環境チェック
sub env0 {
	my ($p1,$p2) = @_;
	my ($domain,$list,$name,$value,@tmp1,@tmp2);
	
	# 該当ドメインの管理情報を得る
	if ($p1 !~ /\@/){
		$domain = $p1;
		$domain =~ s/[.\-]/\\$&/g;
		open(MyFILE3,"$mailroot/$domainadmintab") || return();
			while(<MyFILE3>){
				$_ = &dec_utf($_);
				chomp;
				s/"//g;
				if (/^#/ || /^\s*$/ || !/\t/){next;}
				@tmp1 = split(/\t/,$_);
				if (!@K4D && $tmp1[0] =~ /^$domain$/i){@K4D = @tmp1;}
			}
		close(MyFILE3);
	}
	else {
	# 該当個人用リストの管理情報を得る
		$list = $p1;
		($name,$domain) = split(/\@/,$list);
		($list) = &mod_str($list);
		open(MyFILE3,"$mailroot/$listadmintab") || return();
			while(<MyFILE3>){
				$_ = &dec_utf($_);
				chomp;
				s/"//g;
				next if (/^$/ || /^\s*$/ || !/\t/);
				@tmp1 = split(/\t/,$_);
				@K4L = @tmp1 if (!@K4L && $tmp1[0] =~ /^$list$/i);
			}
		close(MyFILE3);
	}
}

## 個人用メーリングリストオプションを選択
sub env1 {
	$k4listadmin = "<input type='hidden' name='Ladmin0' value='$Ladmin0'>";
	$k4listadmin .= "&nbsp; <select name='Ladmin'>";
	$k4listadmin .= "<option value=''>無指定</option>";
	foreach(@usertotal){
		$_ = "<option value='$_'>$_</option>";
		s/>$Ladmin<\// selected$&/i;
		$k4listadmin .= $_;
	}
	$k4listadmin .="</select> <a href=\"JavaScript:opn_win('$help+Ladmin'$wsize)\">(管理者の選択)</a><br>";
	$k4listadmin .= "&nbsp; <input name='Lmember' size=9 maxlength=9 value='$Lmember'> ";
	$k4listadmin .= "<a href=\"JavaScript:opn_win('$help+Lmember'$wsize)\">メンバー数(最大 $maxlistmember人)</a><br>";
	
	if ($plmsgsize){
		if ($Lmsgsize){$tmp = 'checked';} else {$tmp = '';}
		$k4listadmin .= "<input type='checkbox' name='Lmsgsize' $tmp value='1'>";
		$k4listadmin .= "<a href=\"JavaScript:opn_win('$help+Lmsgsize'$wsize)\">メッセージサイズ制限の設定を許可</a><br>";
	}
	
	if ($plstag){
		if ($Lstag){$tmp = 'checked';} else {$tmp = '';}
		$k4listadmin .= "<input type='checkbox' name='Lstag' $tmp value='1'>";
		$k4listadmin .= "<a href=\"JavaScript:opn_win('$help+Lstag'$wsize)\">Subject: タグの設定を許可</a><br>";
	}
	
	if ($plffrom){
		if ($Lfrom){$tmp = 'checked';} else {$tmp = '';}
		$k4listadmin .= "<input type='checkbox' name='Lfrom' $tmp value='1'>";
		$k4listadmin .= "<a href=\"JavaScript:opn_win('$help+Lfrom'$wsize)\">From: アドレス固定の設定を許可</a><br>";
	}
	
	if ($plattach){
		if ($Lattach){$tmp = 'checked';} else {$tmp = '';}
		$k4listadmin .= "<input type='checkbox' name='Lattach' $tmp value='1'>";
		$k4listadmin .= "<a href=\"JavaScript:opn_win('$help+Lattach'$wsize)\">添付ファイル削除の設定を許可</a><br>";
	}
	
	if ($plmsgid){
		if ($Lmsgid){$tmp = 'checked';} else {$tmp = '';}
		$k4listadmin .= "<input type='checkbox' name='Lmsgid' $tmp value='1'>";
		$k4listadmin .= "<a href=\"JavaScript:opn_win('$help+Lmsgid'$wsize)\">Message-Id: タグ追加の設定を許可</a><br>";
	}
	
	if ($plheader){
		if ($Lheader){$tmp = 'checked';} else {$tmp = '';}
		$k4listadmin .= "<input type='checkbox' name='Lheader' $tmp value='1'>";
		$k4listadmin .= "<a href=\"JavaScript:opn_win('$help+Lheader'$wsize)\">ヘッダ/フッタの設定を許可</a><br>";
	}
	
	if ($pldeny){
		if ($Ldeny){$tmp = 'checked';} else {$tmp = '';}
		$k4listadmin .= "<input type='checkbox' name='Ldeny' $tmp value='1'>";
		$k4listadmin .= "<a href=\"JavaScript:opn_win('$help+Ldeny'$wsize)\">受信拒否の設定を許可</a><br>";
	}
	
	if ($plsubscribe){
		if ($Lsubscribe){$tmp = 'checked';} else {$tmp = '';}
		$k4listadmin .= "<input type='checkbox' name='Lsubscribe' $tmp value='1'>";
		$k4listadmin .= "<a href=\"JavaScript:opn_win('$help+Lsubscribe'$wsize)\">空メッセージ投稿による登録/削除の設定を許可</a><br>";
	}
	
	if ($plrobot){
		if ($Lrobot){$tmp = 'checked';} else {$tmp = '';}
		$k4listadmin .= "<input type='checkbox' name='Lrobot' $tmp value='1'>";
		$k4listadmin .= "<a href=\"JavaScript:opn_win('$help+Lrobot'$wsize)\">リストプロセッサの設定を許可</a><br>";
	}
	
	if ($Ldel){$tmp = 'checked';} else {$tmp = '';}
	$k4listadmin .= "<input type='checkbox' name='Ldel' $tmp value='1'>";
	$k4listadmin .= "<a href=\"JavaScript:opn_win('$help+Ldel'$wsize)\">このリストの削除を許可</a><br>";
	
	$k4listadmin = 'このリストは他ドメインのユーザが管理しています。' if !$LadminOK;
	
	$K4 = <<"EOF";
$hr
$fs5 ■<a href="JavaScript:opn_win('$help+listadmin'$wsize)">ユーザによるリストの管理</a></td></tr>
<tr><td height=2></td></tr>
<tr><td colspan=2>$k4listadmin</td></tr>
<tr><td height=8></td></tr>
<tr><td colspan=2>
EOF
	&print_utf($K4);
}

## K4アクセス権を得る
sub env2 {
	my ($tmp);
	
	if ($k4login){$tmp = 'checked';}
	$k4stat = "<dd><input type='checkbox' name='k4login' $tmp value='1'> ";
	$k4stat .= "<a href=\"JavaScript:opn_win('$help+k4pass'$wsize)\">ログインを許可</a><br>";
	
	if (!$k4password){$tmp = 'checked';} else {$tmp = '';}
	$k4stat .= "<dd><input type='checkbox' name='k4password' $tmp value='1'> ";
	$k4stat .= "<a href=\"JavaScript:opn_win('$help+k4password'$wsize)\">パスワードの更新を許可</a><br>";
	
	if (!$k4forward){$tmp = 'checked';} else {$tmp = '';}
	$k4stat .= "<dd><input type='checkbox' name='k4forward' $tmp value='1'> ";
	$k4stat .= "<a href=\"JavaScript:opn_win('$help+k4forward'$wsize)\">転送の指定を許可</a><br>";
	
	if ($k4allowmail){$tmp = 'checked';} else {$tmp = '';}
	if ($allowmail){
		$k4stat .= "<dd><input type='checkbox' name='k4allowmail' $tmp value='1'> ";
		$k4stat .= "<a href=\"JavaScript:opn_win('$help+mailbox'$wsize)\">メールボックスの管理を許可</a><br>";
	}
	
	if ($k4allowallow){$tmp = 'checked';} else {$tmp = '';}
	if ($allowallow){
		$k4stat .= "<dd><input type='checkbox' name='k4allowallow' $tmp value='1'> ";
		$k4stat .= "<a href=\"JavaScript:opn_win('$help+forcefrom'$wsize)\">受信制限(受信許可)の指定を許可</a>$na<br>";
	}
	
	if ($k4allowdeny){$tmp = 'checked';} else {$tmp = '';}
	if ($allowdeny){
		$k4stat .= "<dd><input type='checkbox' name='k4allowdeny' $tmp value='1'> ";
		$k4stat .= "<a href=\"JavaScript:opn_win('$help+deny'$wsize)\">受信拒否の指定を許可</a>$na<br>";
	}
	
	if ($k4allowantispam){$tmp = 'checked';} else {$tmp = '';}
	if ($allowantispam){
		$k4stat .= "<dd><input type='checkbox' name='k4allowantispam' $tmp value='1'> ";
		$k4stat .= "<a href=\"JavaScript:opn_win('$help+antispam'$wsize)\">アンチ・スパムの指定を許可</a>$na<br>";
	}
	
	if ($k4allownotify){$tmp = 'checked';} else {$tmp = '';}
	if ($allownotify){
		$k4stat .= "<dd><input type='checkbox' name='k4allownotify' $tmp value='1'> ";
		$k4stat .= "<a href=\"JavaScript:opn_win('$help+notify'$wsize)\">お知らせメールの指定を許可</a>$na<br>";
	}
	
	if ($k4autoreply){$tmp = 'checked';} else {$tmp = '';}
	if ($autoreply){
		$k4stat .= "<dd><input type='checkbox' name='k4autoreply' $tmp value='1'> ";
		$k4stat .= "<a href=\"JavaScript:opn_win('$help+autoreply'$wsize)\">自動応答の指定を許可</a>$na<br>";
	}
	
	if ($k4popsync){$tmp = 'checked';} else {$tmp = '';}
	if ($popsync){
		$k4stat .= "<dd><input type='checkbox' name='k4popsync' $tmp value='1'> ";
		$k4stat .= "<a href=\"JavaScript:opn_win('$help+popsync'$wsize)\">自動受信の指定を許可</a><br>";
	}
	
	if ($k4fservice){$tmp = 'checked';} else {$tmp = '';}
	if ($fservice){
		$k4stat .= "<dd><input type='checkbox' name='k4fservice' $tmp value='1'> ";
		$k4stat .= "<a href=\"JavaScript:opn_win('$help+finger'$wsize)\">ユーザ情報の参照を許可</a><br>";
	}
	
	if ($k4allowusertab){$tmp = 'checked';} else {$tmp = '';}
	if ($allowusertab){
		$k4stat .= "<dd><input type='checkbox' name='k4allowusertab' $tmp value='1'> ";
		$k4stat .= "<a href=\"JavaScript:opn_win('$help+usertab'$wsize)\">個人情報の更新を許可</a><br>";
	}
	
	if ($k4allowdistribute){$tmp = 'checked';} else {$tmp = '';}
	if ($allowdistribute){
		$k4stat .= "<dd><input type='checkbox' name='k4allowdistribute' $tmp value='1'> ";
		$k4stat .= "<a href=\"JavaScript:opn_win('$help+distribute'$wsize)\">振り分けの指定を許可</a>$na<br>";
	}
	
	if ($k4allowbigfile){$tmp = 'checked';} else {$tmp = '';}
	if ($allowbigfile){
		$k4stat .= "<dd><input type='checkbox' name='k4allowbigfile' $tmp value='1'> ";
		$k4stat .= "<a href=\"JavaScript:opn_win('$help+bigfile'$wsize)\">ビッグファイル送付機能の利用を許可</a>$na<br>";
	}
	
	if ($k4allowbigfile2){$tmp = 'checked';} else {$tmp = '';}
	if ($allowbigfile2){
		$k4stat .= "<dd><input type='checkbox' name='k4allowbigfile2' $tmp value='1'> ";
		$k4stat .= "<a href=\"JavaScript:opn_win('$help+bigfile2'$wsize)\">ビッグファイル受領機能の利用を許可</a>$na<br>";
	}
	
	if ($k4menu){$tmp = 'checked';} else {$tmp = '';}
	$k4stat .= "<dd><input type='checkbox' name='k4menu' $tmp value='1'> ";
	$k4stat .= "<a href=\"JavaScript:opn_win('$help+k4menu'$wsize)\">追加メニューがあれば表示を許可</a>";
	
	$k4stat .= "<hr color='#C0C0C0' size=1 width='80%'>";
	$k4stat .= "<dd><input name='k4mklist' size=3 maxlength=3 value=\"$k4mklist\"> ";
	$k4stat .= "<a href=\"JavaScript:opn_win('$help+listadmin'$wsize)\">個のメーリングリスト開設を許可(最大 $maxlist)</a><br>";
	my ($count,$list);
	if (open(MyFILE3,"$mailroot/$listadmintab")){
			while(<MyFILE3>){
				chomp;
				my @tmp = split(/\t/,$_);
				if ($tmp[1] =~ /^$tuser\@$tdomain$/i){$list .= "<option>$tmp[0]</option>"; $count++;}
			}
		close(MyFILE3);
		if ($list){
			if ($count > 5){$count = 5;}
			$k4stat .= "<dd>&nbsp; &nbsp; &nbsp; &nbsp; [運営中のリスト]<br>";
			$k4stat .= "<dd>&nbsp; &nbsp; &nbsp; &nbsp; <select size=$count>$list</select>";
		}
	}
	$k4stat .= "<hr color='#C0C0C0' size=1 width='80%'>";
	
	$k4mlist =~ s/ +/\n/g if $k4mlist;
	$k4stat .= "<dd><li><a href=\"JavaScript:opn_win('$help+mlist'$wsize)\">閲読できるメーリングリストアーカイブ</a><br>";
	$k4stat .= "<dd><textarea name='k4mlist' cols=30 rows=5 wrap='soft'>$k4mlist</textarea><br>";
}

## メーリングリストの受信拒否リストを得る
sub getdenyinfo {
	local($domain,$user) = @_;
	$denylist = ''; @denylist = ();
	$denytotal = 0;
	
	# リストを得る
	if (open(MyFILE3,"$mailroot/domains/$domain/$user/$xmailcfg/deny.tab")){
			while (<MyFILE3>){
				chomp;
				next if (/^\s*$/ || /[^\w".\-\@\t]/i || !/@/);
				s/^\s+//;
				s/\s+$//;
				push(@denylist,$_);
			}
		close(MyFILE3);
		foreach(sort(@denylist)){
			$denylist .= "<option value=\"$_\">$_</option>";
			$denytotal++;
		}
	}
	$currentstat = <<"EOF";
<table cellpadding=3>
<tr><td>$table1
<tr><td>現在の登録数:&nbsp;&nbsp;&nbsp;</td>
<td><b>$denytotal</b>/max$DenyMax</td></tr>
</table></td></tr>
</table>
EOF
}

## ページヘッダを表示
sub header {
	local($i) = @_;
	local($a0,$a1,$a2,$a3,$a4,$a5,$a6,$menu);
	$a0 = "| <a href='$dhome?$tdomain'>トップ</a> ";
	if ($maxuser){$a1 = "| <a href='$duser?$tdomain'>ユーザ</a> ";}
	if ($maxlist){$a2 = "| <a href='$dlist?$tdomain'>リスト</a> ";}
	if ($maxalias){$a3 = "| <a href='$dalias?$tdomain'>エイリアス</a> ";}
	$a4 = "| <a href='$daddress?$tdomain'>アドレス帳</a> ";
	$a5 = "| <a href='$dlog?$tdomain'>アクセスログ</a> ";
	$a6 = "| <a href='$dmenu?$tdomain'>追加メニュー</a> ";
	if ($msg_d eq ''){
		if ($i eq 'home'){$menu = "$a1$a2$a3$a4$a6$a5 |";}
		elsif ($i eq 'user'){$menu = "$a0$a2$a3$a4$a6$a5 |";}
		elsif ($i eq 'list'){$menu = "$a0$a1$a3$a4$a6$a5 |";}
		elsif ($i eq 'alias'){$menu = "$a0$a1$a2$a4$a6$a5 |";}
		elsif ($i eq 'address'){$menu = "$a0$a1$a2$a3$a6$a5 |";}
		elsif ($i eq 'menu'){$menu = "$a0$a1$a2$a3$a4$a5 |";}
		elsif ($i eq 'log'){$menu = "$a0$a1$a2$a3$a4$a6 |";}
		else {}
	}
	
	print <<"EOF";
Content-Type: text/html; charset=$charset
CacheControl: no-cache
Pragma: no-cache
Expires: -1\n
<html><head>$charcss</head>
EOF
	$K4 = <<"EOF";
<body $bodyp class='doc131' topmargin=2 leftmargin=4 marginheight=2 marginwidth=4 $cbody0>
$table0
<tr valign='bottom'><td>
<img src='$idir/admin.gif' width=24 height=24 title='$tdomainドメインの管理' border=0></td>
<td class='doc17' width='100%' nowrap>
&nbsp;<b>$tdomain</b> $fs5 の管理$fe</td>
<td nowrap>$menu&nbsp;</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#C0C0C0' colspan=3 height=!>$null</td></tr>
<tr><td height=10></td></tr>
</table>
EOF
	&print_utf($K4);
}

## メーリングリストの設定オプションを表示
sub printliststat {
	&htmlconv(qw(RealName ForceFrom Tag));
	$RealName = '' if $RealName =~ /^\?+$/;
	$CompanyName = '' if $CompanyName =~ /^\?+$/;
	$ReceiveEnablechk = 'checked' if $ReceiveEnable == 1;
	if ($Robot =~ /RW*|W*R|QX*|X*Q/i){
		$lpchk = 'checked';
		$lpermchk = 'checked' if $Robot =~ /RW|WR|QX|XQ/i;
	}
	foreach(qw(Attachment ClosedML Deny Log Footer GoodbyeMessage Header Log MessageID 
		RobotHelp RobotInfo WelcomeMessage Subscribe)){
		if ($$_){${$_ . 'chk'} = 'checked';}
	}
	if (!$UseReplyTo){
		if ($ReplyTo =~ /^$emreg$/i){$rt3 = 'checked';}
		else {$rt1 = 'checked'; $ReplyTo = '';}
	} else {
		$rt2 = 'checked';
		$ReplyTo = '';
	}
	
	$K4 = <<"EOF";
	<tr valign="top"><td nowrap>
	<a href="JavaScript:opn_win('$help+replyto'$wsize)">・ 返信(Reply-To:)アドレス:</a>　&nbsp;</td>
	<td width='100%'>
	<input type='radio' name='UseReplyTo' value='0' $rt1>何も付加しない<br>
	<input type='radio' name='UseReplyTo' value='1' $rt2>このリストアドレスを付加<br>
	<input type='radio' name='UseReplyTo' value='2' $rt3>以下のアドレスを付加<br>
	<input name='ReplyTo' size=25 maxlength=100 value='$ReplyTo' $nosubmit>$na</td></tr>
	<tr><td><a href="JavaScript:opn_win('$help+realname'$wsize)">・ リストの説明(日本語可):</a></td>
	<td><input name='RealName' size=25 maxlength=50 value='$RealName' $nosubmit></td></tr>
	<tr><td><a href="JavaScript:opn_win('$help+companyname'$wsize)">・ 所属組織(日本語可):</a></td>
	<td><input name='CompanyName' size=25 maxlength=50 value='$CompanyName' $nosubmit></td></tr>
	<tr><td><a href="JavaScript:opn_win('$help+tag'$wsize)">・ Subject:付加のタグ:</a></td>
	<td><input name='Tag' size=25 maxlength=$tagmax value='$Tag' $nosubmit>$na</td></tr>
	<tr><td><a href="JavaScript:opn_win('$help+forcefrom'$wsize)">・ From:アドレスの固定:</a></td>
	<td><input name='ForceFrom' size=25 maxlength=$tagmax value='$ForceFrom' $nosubmit>$na</td></tr>
	<tr><td nowrap><a href="JavaScript:opn_win('$help+returnpath'$wsize)">・ 返送(Return-Path:)アドレス:</a></td>
	<td><input name='ListSender' size=25 maxlength=50 value='$ListSender' $nosubmit></td></tr>
	<tr><td><a href="JavaScript:opn_win('$help+msglimit'$wsize)">・ メッセージサイズ制限:</a></td>
	<td><input name='MessageSize' size=7 maxlength=5 value='$MessageSize' $nosubmit>
	KB(最大 ${maxlistmsgsize}KB)$na</td></tr>
	<tr><td colspan=2><input type='checkbox' name='ClosedML' $ClosedMLchk value='1'>
	<a href="JavaScript:opn_win('$help+capacity'$wsize)">このリストへの投稿は登録メンバーのみに制限する</td></tr>
	<tr><td colspan=2><input type='checkbox' name='Subscribe' $Subscribechk value='1'>
	<a href="JavaScript:opn_win('$help+join'$wsize)">空メッセージ投稿による登録/削除を実行する$na</td></tr>
	<tr><td colspan=2><input type='checkbox' name='MessageID' $MessageIDchk value='1'>
	<a href="JavaScript:opn_win('$help+messageid'$wsize)">Message-ID:ヘッダがなければ付加する$na</td></tr>
	<tr><td colspan=2><input type='checkbox' name='Attachment' $Attachmentchk value='1'>
	<a href="JavaScript:opn_win('$help+attach'$wsize)">メッセージ中の添付ファイルを削除する</a>$na</td></tr>
	<tr><td colspan=2><input type='checkbox' name='Deny' $Denychk value='1'>
	<a href="JavaScript:opn_win('$help+deny'$wsize)">特定アドレスからの受信を拒否する</a>$na</td></tr>
	<tr><td colspan=2><input type='checkbox' name='Log' $Logchk value='1'>
	<a href="JavaScript:opn_win('$help+log'$wsize)">投稿記事のアーカイブを作成する</a>$na</td></tr>
	<tr><td colspan=2><input type='checkbox' name='Header' $Headerchk value='1'>
	<a href="JavaScript:opn_win('$help+header'$wsize)">配信メッセージに以下のヘッダを付加する（日本語注意）</a>$na<br>
	<textarea name='headertext' cols=50 rows=4 wrap='soft'>$headertext</textarea></td></tr>
	<tr><td colspan=2><input type='checkbox' name='Footer' $Footerchk value='1'>
	<a href="JavaScript:opn_win('$help+footer'$wsize)">配信メッセージに以下のフッタを付加する（日本語注意）</a>$na<br>
	<textarea name='footertext' cols=50 rows=4 wrap='soft'>$footertext</textarea></td></tr>
	<tr><td height=4></td></tr>
	<tr><td class='doc15' colspan=2>$hr
	■<a href="JavaScript:opn_win('$help+listp'$wsize)">リストプロセッサによる自動処理</a>$na</td></tr>
	<tr><td colspan=2><input type='checkbox' name='lp' $lpchk value='1'>
	<a href="JavaScript:opn_win('$help+subscribe'$wsize)">リストプロセッサ機能を利用する</a></td></tr>
	<tr><td colspan=2><input type='checkbox' name='lperm' $lpermchk value='RW'>
	<a href="JavaScript:opn_win('$help+perm'$wsize)">投稿を許可するメンバーとして登録する</a></td></tr>
	<tr><td><a href="JavaScript:opn_win('$help+sender'$wsize)">・ メッセージのFrom:アドレス:</a></td>
	<td><input name='ListAdmin' size=25 maxlength=50 value='$ListAdmin' $nosubmit></td></tr>
	<tr><td nowrap><a href="JavaScript:opn_win('$help+report'$wsize)">・ 自動処理の通知先アドレス:</a></td>
	<td><input name='Owner' size=25 maxlength=50 value='$Owner' $nosubmit></td></tr>
	<tr><td><a href="JavaScript:opn_win('$help+limit'$wsize)">・ 自動登録による定員:</a></td>
	<td><input name='MaxUser' size=7 maxlength=5 value='$MaxUser' $nosubmit>(最大 $maxlistmember\人)</td></tr>
	<tr><td colspan=2 nowrap><input type='checkbox' name='WelcomeMessage' $WelcomeMessagechk value='1'>
	<a href="JavaScript:opn_win('$help+welcome'$wsize)">自動登録時に以下のメッセージを送信する(日本語可)</a><br>
	　用件: <input name='welcomesubject' size=50 maxlength=80 value='$welcomesubject' $nosubmit><br>
	<textarea name='welcometext' cols=50 rows=4 wrap='soft'>$welcometext</textarea></td></tr>
	<tr><td colspan=2 nowrap><input type='checkbox' name='GoodbyeMessage' $GoodbyeMessagechk value='1'>
	<a href="JavaScript:opn_win('$help+bye'$wsize)">自動削除時に以下のメッセージを送信する(日本語可)</a><br>
	　用件: <input name='goodbyesubject' size=50 maxlength=80 value='$goodbyesubject' $nosubmit><br>
	<textarea name='goodbyetext' cols=50 rows=4 wrap='soft'>$goodbyetext</textarea></td></tr>
	<tr><td colspan=2 nowrap><input type='checkbox' name='RobotHelp' $RobotHelpchk value='1'>
	<a href="JavaScript:opn_win('$help+helpcmd'$wsize)">HELP コマンドに対して以下のメッセージを送信する(日本語可)</a><br>
	　用件: <input name='helpsubject' size=50 maxlength=80 value='$helpsubject' $nosubmit><br>
	<textarea name='helptext' cols=50 rows=4 wrap='soft'>$helptext</textarea></td></tr>
	<tr><td colspan=2 nowrap><input type='checkbox' name='RobotInfo' $RobotInfochk value='1'>
	<a href="JavaScript:opn_win('$help+infocmd'$wsize)">INFO コマンドに対して以下のメッセージを送信する(日本語可)</a><br>
	　用件: <input name='infosubject' size=50 maxlength=80 value='$infosubject' $nosubmit><br>
	<textarea name='infotext' cols=50 rows=4 wrap='soft'>$infotext</textarea></td></tr>
	<tr><td height=4></td></tr>
	<tr><td class='doc15' colspan=2>
EOF
	&print_utf($K4);
	
	&env1 if @usertotal;
	my $tmp = "$hr<input type='submit' value='プロパティを更新する'>" if $cgi eq "$dlistedit";
	
	$K4 = <<"EOF";
	$hr
	■<a href="JavaScript:opn_win('$help+memo'$wsize)">管理用メモ</a>&nbsp;<span class='doc131'>(日本語可)</span><br>
	<textarea name='memo' cols=50 rows=4 wrap='soft'>$memo</textarea>
	$tmp</td></tr>
	<tr><td colspan=2></td></tr>
	</table></td></tr>
</table>
</form>
EOF
	&print_utf($K4);
}

## ユーザの設定オプションを表示
sub printuserstat {
	$K4 = <<"EOF";
<tr><td class='doc15' colspan=2>$hr
■<a href="JavaScript:opn_win('$help+k4'$wsize)">本ツール集へのアクセス権</a></td></tr>
<tr><td colspan=2>$k4stat</td></tr>
<tr><td height=4></td></tr>
<tr><td class='doc15' colspan=2>
$hr
■<a href="JavaScript:opn_win('$help+personal'$wsize)">個人情報</a>&nbsp;<span class='doc131'>(名前/住所は日本語が使えます)</span></td></tr>
<tr><td align='right'>名前:</td>
<td><input name='RealName' size=25 maxlength=50 value='$RealName' $nosubmit></td></tr>
<tr><td align='right'>所属組織:</td>
<td><input name='CompanyName' size=25 maxlength=50 value='$CompanyName' $nosubmit></td></tr>
<tr><td align='right'>電話番号:</td>
<td><input name='Telephone' size=25 maxlength=12 value='$Telephone' $nosubmit><br><tr>
<td align='right'>住所:</td>
<td><input name='Address' size=40 maxlength=100 value='$Address' $nosubmit></td></tr>
<tr><td align='right'>ホームページ:</td>
<td><input name='HomePage' size=40 maxlength=100 value='$HomePage' $nosubmit></td></tr>
<tr><td height=4></td></tr>
<tr><td class='doc15' colspan=2>
$hr
■<a href="JavaScript:opn_win('$help+memo'$wsize)">管理用メモ</a>&nbsp;<span class='doc131'>(日本語が使えます)</span></td></tr>
<tr><td colspan=2><textarea name='memo' cols=50 rows=4 wrap='soft'>$memo</textarea></td></tr>
EOF
	&print_utf($K4);
}

## リスト情報を保存(user.def, config.tab)
sub savelistenv {
	my($domain,$user) = @_;
	my($arg,$file,$tagflg,$tmp,@tmp);
	
	if ($ClosedML eq ''){$ClosedML = 0;}
	if ($ReceiveEnable eq ''){$ReceiveEnable = 0;}
	if ($MaxUser > $maxlistmember || $MaxUser eq ''){$MaxUser = $maxlistmember;}
	if ($lp){
		if (!$ReceiveEnable){$lperm =~ y/RW/QX/;}
		else {$lperm =~ y/QX/RW/;}
		$Robot = $lperm;
		if (!$Robot){$Robot = 'R';}
	} else {$lperm = '';}
	&saveenv('userm',$domain,$user,'RealName','CompanyName','ClosedML','ListSender','ReceiveEnable','UseReplyTo');
	&saveenv('k4m',$domain,$user,'Attachment','Deny','Footer','ForceFrom','GoodbyeMessage','Header',
		'ListAdmin','Log','MaxUser','ForceFrom','MessageID','MessageSize','Owner','ReplyTo','Robot','RobotHelp',
		'RobotInfo','Subscribe','Tag','WelcomeMessage');
	
	# ヘッダ/フッタ/Welcome/Goodbye/Help/Infoテキストを保存
	foreach(qw(footer goodbye header help info welcome)){
		my ($txt1,$txt2) = (${$_.'text'},${$_.'subject'});
		$txt1 =~ s/\r*\n/\n/g;
		$txt1 =~ s/\s*$//;
		Encode::_utf8_off($txt1);
		Encode::_utf8_off($txt2);
		Encode::from_to($txt1,$charset,'JIS');
		Encode::from_to($txt2,$charset,'JIS');
		open(MyFILE3,">$mailroot/domains/$domain/$user/$xmailcfg/$_.tab");
			flock(MyFILE3,2);
			if (/^footer|header$/){} else {print MyFILE3 "[Subject] $txt2\n";}
			print MyFILE3 "$txt1\n";
		close(MyFILE3);
	}
	
	if (!$ReceiveEnable){$extmsg .= '<br>●アカウントは停止されています。';}
	
	# 個人用リスト管理情報を更新
	if (!$LadminOK){return();}
	$file = "$mailroot/$listadmintab";
	foreach(qw(msgsize stag attach msgid header deny robot del from subscribe log arc)){
		if (${'L'.$_} eq ''){${'L'.$_} = 0;}}
	my $line = "$user\@$domain\t$Ladmin\t$Lmember\t$Lmsgsize\t$Lstag\t$Lattach\t$Lmsgid\t";
	$line .= "$Lheader\t$Ldeny\t$Lrobot\t$Ldel\t$Lfrom\t$Lsubscribe\t$Llog\t$Larc\n";
	$tmp = ''; @tmp = ();
	if (open(MyFILE3,$file)){
			while(<MyFILE3>){
				if (/^#/ || !/\t/){next;}
				if (!$tmp && /^$user\@$domain\t$Ladmin0\t/i){$tmp = 1; next;}	# 旧管理情報を削除
				push(@tmp,$_);
			}
		close(MyFILE3);
	}
	if ($Ladmin){unshift(@tmp,$line);}
	
	$tmp = "### リスト名 管理者 最大メンバ数 最大MSGサイズ Subjectタグ 添付削除 MsgID ヘッダ/フッタ\n";
	$tmp .= "### 受信拒否 リストプロセッサ 削除許可 From:固定 空メール登録 ログ閲覧 書庫作成\n\n";
	Encode::_utf8_off($tmp);
	Encode::from_to($tmp,$charset,$charsetE);
	open(MyFILE3,">$file");
		flock(MyFILE3,2);
		print MyFILE3 $tmp;
		print MyFILE3 @tmp;
	close(MyFILE3);
}

## メモを保存
sub savememo {
	local($domain,$user) = @_;
	local($tmp);
	$memo =~ s/\r*\n/\n/g;
	$memo =~ s/^\n+//;
	$memo =~ s/\s+$/\n/;
	$tmp = $memo;
	Encode::_utf8_off($tmp);
	Encode::from_to($tmp,$charset,$charsetE);
	open(MyFILE3,">$mailroot/domains/$domain/$user/$xmailcfg/memo.tab") || return();
		flock(MyFILE3,2);
		print MyFILE3 $tmp;
	close(MyFILE3);
}

## リストメニュー
sub selectmenu_l {
	local($dell,$member,$deny,$property,$sendmail,$del);
	foreach(qw(member deny property sendmail del)){if ($menuid eq $_){$$_ = 'checked';}}
	if (!$k4fixed){
		$dell = "<input type='radio' name='go' value='del' $del $confirm1> ";
		$dell .= "<a href=\"JavaScript:opn_win('$help+deluser'$wsize)\">アカウントを削除</a>";
	}
	$selectmenu = <<"EOF";
<table cellpadding=4 cellspacing=0 class='doc131' border=0>
<tr><td align='center' $bgcolor2>
<form method='post' action='$dsel'>
<input type='hidden' name='tdomain' value='$tdomain'>
<input type='hidden' name='MU' value='M'>
<select name='id' size=9>
<option value='' selected>選択してください</option>
$select_list
</select></td></tr>
<tr><td $bgcolor2 nowrap>
<input type='radio' name='go' value='member' $member>
<a href="JavaScript:opn_win('$help+menumember'$wsize)">メンバーの管理</a><br>
<input type='radio' name='go' value='deny' $deny>
<a href="JavaScript:opn_win('$help+menudeny'$wsize)">受信拒否の管理</a><br>
<input type='radio' name='go' value='property' $property>
<a href="JavaScript:opn_win('$help+property'$wsize)">プロパティを編集</a><br>
<input type='radio' name='go' value='sendmail' $sendmail>
<a href="JavaScript:opn_win('$help+message'$wsize)">メッセージを送信</a><br>
$dell</td></tr>
<tr><td $bgcolor2><input type='submit' value='選択して実行'></td>
<td></form></td></tr>
</table>
EOF
	&htmlconv(qw(RealName Tag footertext headertext goodbyesubject goodbyetext 
		welcometext welcomesubject memo subject text));
}

## ユーザメニュー
sub selectmenu_u {
	local($delu,$property,$sendmail,$loginmsg,$del);
	foreach(qw(property sendmail loginmsg del)){if ($menuid eq $_){$$_ = 'checked';}}
	if (!$k4fixed){
		$delu = "<input type='radio' name='go' value='del' $del $confirm1> ";
		$delu .= "<a href=\"JavaScript:opn_win('$help+deluser'$wsize)\">アカウントを削除</a>";
	}
	$selectmenu = <<"EOF";
<table cellpadding=4 cellspacing=0 class='doc131' border=0>
<tr><td align='center' $bgcolor2>
<form method='post' action='$dsel'>
<input type='hidden' name='tdomain' value='$tdomain'>
<input type='hidden' name='MU' value='U'>
<select name='id' size=10>
<option value='' selected>選択してください</option>$select_user</select></td></tr>
<tr><td $bgcolor2 nowrap>
<input type='radio' name='go' value='property' $property>
<a href="JavaScript:opn_win('$help+property'$wsize)">プロパティを編集</a><br>
<input type='radio' name='go' value='sendmail' $sendmail>
<a href="JavaScript:opn_win('$help+message'$wsize)">メッセージを送信</a><br>
<input type='radio' name='go' value='loginmsg' $loginmsg>
<a href="JavaScript:opn_win('$help+loginmsg'$wsize)">ログインMSG編集</a><br>
$delu</td></tr>
<tr><td $bgcolor2><input type='submit' value='選択して実行'></td>
<td></form></td></tr>
</table>
EOF
	&htmlconv(qw(RealName Telephone Address HomePage memo));
}

1;
