;### uK4 - ファイルの管理共通
;### フォルダ・ファイル情報はUTF8で保存(旧システムとの互換が失われる)
;# key4:ソートフィールド、key5:ソート方法、key6:表示ページ
;# key7:フォルダ(階層連結)、key8:ファイルID、key9以降は随時利用
;# 各フォルダ内にindex.txt、profile.txt
use File::Find;
use utf8;
$startcgi  = 'file_start.cgi';	# トップページ用
$downloadcgi = 'file_download.cgi';	# ファイルダウンロード用
$listcgi = 'file_list.cgi';		# ファイル一覧
$managecgi = 'file_manage.cgi';	# フォルダ作成、ファイル/フォルダのコピー・移動・削除
$searchcgi = 'file_search.cgi';	# 検索用
$uploadcgi = 'file_upload.cgi';	# アップロード用
$regexp = '\d{3}';				# ユーザフォルダ正規表現
$ttl = 3600;					# インデックス有効時間
$index = 'index.txt';			# ファイル/フォルダのインデックスファイル(各フォルダに存在)
$dirindex = 'index_dir.txt';	# 全フォルダのリスト(ルートにのみ存在)
$profile = 'profile.txt';		# フォルダ情報定義ファイル
$rootname = 'システムルート';	# ファイルルート名
$fsspace = 10000 if !$fsspace;	# [デフォルト] 最大容量
$fssize = 1000 if !$fssize;		# [デフォルト] 最大ファイルサイズ
$fslevel = 0 if !$fslevel;		# [デフォルト] フォルダ階層作成許可数
$fsfolders = 10 if !$fsfolders;	# [デフォルト] フォルダ作成許可数
$fsfiles = 100 if !$fsfiles;	# [デフォルト] フォルダ内ファイル作成許可数
$fsitem = 30 if !$fsitem;		# [デフォルト] ページ表示アイテム数
$fsroot =~ s/[\\\/]+$//;
$fsroot =~ s/\\/\//g;
&auth();
$fsroot .= "/$domain1/$user1";
exit if !$k4fsallow;
foreach (qw(fssize fsspace fsfolders fsfiles fsitem)){${'k4'.$_} = $$_ if ${'k4'.$_} eq '';}
$class = "class='doc13'";
$Root = 'FileRoot';
$arrowU2 = "<a href='#top'><img src='$idir/null.gif' width=10 height=10 border=0 alt='上へ'></a>";
($bgc1,$bgc2) = ("bgcolor='#fff0f0'","bgcolor='#ffe0e0'");
$buttons = "<input type='submit' name='move' value='移動' title='チェックをつけたファイル・フォルダを移動します'>" if $fslevel;
$buttons .= "<input type='submit' name='remove' value='削除' title='チェックをつけたファイル・フォルダを削除します'>";
$buttons .= "<input type='submit' name='rename' value='変更' title='チェックをつけたファイル・フォルダの名前を変更します'>";
$fileIcon = "<img src='$idir/file.gif' height=13 width=15 title='ファイル' border=0>";
$folderIcon = "<img src='$idir/folder3.gif' height=13 width=15 title='フォルダ' border=0>";
$key7 = '' if $key7 eq '_';

## フォルダ情報/使用量を得る(再帰処理)
sub get_dirs {
	my ($s1,$s2) = @_;			# s1:対象フォルダ、s2:再帰処理識別フラグ
	my $dir = "$fsroot/$Root";
	$dir .= "/$s1" if $s1;
	my $myindex = "$fsroot/$Root/$dirindex";
	my $searchcount = split(/\//,$s1);		# 検索階層
	
	# 有効インデックスがあれば
	if (!$s2 && -f $myindex && (stat($myindex))[9] + $ttl > time()){
		open(FILE,$myindex);
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				push(@list,$_);
			};
		close(FILE);
		return @list;
	}
	
	# フォルダ情報を得る
	my %i = &get_info($dir);
	$i{Name} = '(不明)' if $i{Name} eq '';
	$i{Name} = $rootname if !$s1;
	$i{Name} =~ s/</&lt;/g;
	$i{Name} =~ s/>/&gt;/g;
	$i{Name} =~ s/"/&quot;/g;
	
	# 使用量を得る
	my $size;
	foreach my $i (glob("$dir/*")){
		if (-d $i && $i =~ /(\/$regexp)+$/ && $searchcount < $fslevel){
			my $ii = $&;
			$ii =~ s/^\/+//;
			&get_dirs($ii,1);
		} elsif ($i =~ /(\d{10})\.txt$/){
			$size += -s "$dir/$1";
		}
	}
	$size = int(($size+1023) / 1024);
	push(@list,"$s1\t$i{Name}\t$size\n");
	
	# インデックス保存(EUC)
	my @list2 = @list;
	open(FILE,">$myindex");
		foreach (@list2){
			Encode::_utf8_off($_);
			print FILE;
		}
	close(FILE);
	
	@list;
}

## フォルダ移動用リンク一覧作成
sub get_dirs_list {
	my ($currentname,$data);
	
	@list = ();
	my @data = &get_dirs();
	@list = ();
	foreach (&sorting(0,0,0,@data)){
		my ($dir,$name,$size) = split(/\t/,$_);
		$currentname = $name if $key7 eq $dir;
		my ($c,$str);
		if (!$dir){$name = "[$rootname]";}
		else {
			$c = split(/\//,$dir);
			my $c2 = '+-' x --$c;
			$str = "<font color='#c0c0c0'>$c2</font>" if $c;
		}
		$data .= "<tr><td valign='top' nowrap>";
		my ($str1,$str2) = ("<a href='$listcgi?1+0+0+$dir'><font $colorB>","</font></a>");
		($str1,$str2) = ($fs2,$fe) if $dir eq $key7;
		$data .= $str.$str1.$name.$str2."</td></tr>";
	}
	
	($data,$currentname);
}

## 指定フォルダ以下の全フォルダ/全ファイルを得る(@mydirs,@myfiles)
sub get_files {
	my ($dir) = @_;
	my @list;
	push(@mydirs,$dir);
	
	opendir(DIR,$dir);
		@list = readdir(DIR);
	closedir(DIR);
	
	foreach my $file (sort(@list)){
		if (-d "$dir/$file" && $file =~ /^\d{3}$/){&get_files("$dir/$file");}
		elsif ($file =~ /^\d{10}$/){push(@myfiles,"$dir\t$file");}
	}
}

## 指定フォルダの情報を得る
sub get_info {
	my ($dir) = @_;
	$dir =~ s/\/+$//;
	my %info;
	
	open(FILE,"$dir/$profile") || return();
		while (<FILE>){
			chomp;
			$_ = &dec_utf($_,$charset);
			my ($key,$value) = split(/ *= */,$_);
			$value =~ s/</&lt;/g;
			$value =~ s/>/&gt;/g;
			$value =~ s/"/&quot;/g;
			$info{$key} = $value;
		}
	close(FILE);
	
	%info;
}

## 指定フォルダ内のフォルダ/ファイル一覧、使用量を得る
sub get_myfiles {
	my ($dir) = @_;
	local ($size,@files);
	
	if ($dir eq '_'){$dir = '';}
	elsif (!$dir){$dir = $key7;}
	
	my $root = "$fsroot/$Root";
	my $root2 = "$dir/" if $dir;
	$root .= "/$dir" if $dir;
	my $myindex = "$root/$index";
	my ($filecount,$foldercount,@files);
	my $searchcount = split(/\//,$dir);
	
	# 有効インデックスがあれば
	if (-f $myindex && (stat($myindex))[9] + $ttl > time()){
		open(FILE,$myindex);
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				push(@files,$_);
			}
		close(FILE);
		return @files;
	}
	
	# 一覧を新規作成
	foreach my $file (glob("$root/*")){
		if (-d $file){
			if ($file =~ /\/($regexp)$/ && $searchcount < $fslevel && $foldercount <= $k4fsfolders){
				my $folder = $1;
				my %i = &get_info($file);
				push(@files,"$root2$folder\t$i{Name}\t\t$i{Owner}\t$i{Created}\n");
				$foldercount++;
			}
			next;
		}
		next if ($filecount > $k4fsfiles || $file !~ /(\d{10})\.txt$/);
		my $name = $1;
		next if !-f "$root/$name";
		my @tmp;
		open(FILE,$file);
			@tmp = <FILE>;
		close(FILE);
		chomp($tmp[0]);
		my ($tmp) = @tmp;
		$tmp = &dec_utf($tmp,$charset);
		$tmp =~ s/</&lt;/g;
		$tmp =~ s/>/&gt;/g;
		$tmp =~ s/"/&quot;/g;
		my ($fileid,$ext,$realname,$size,$desc,$from,$pri,$date) = split(/\t/,$tmp);
		if (!$desc){$desc = $realname;}
		else {$desc .= "($realname)" if $desc ne $realname;}
		push(@files,"$fileid\t$desc\t$size\t$from\t$date\n");
		$filecount++;
	}
	
	# インデックス保存
	my @files2 = @files;
	open(FILE,">$myindex");
		foreach (@files2){
			Encode::_utf8_off($_);
			print FILE;
		}
	close(FILE);
	
	@files;
}

## システムルート以下の総使用量を得る
sub get_total_space {
	local $space;
	find(sub {$space += -s if (-f && /\d{10}$/)}, "$fsroot/$Root");
	$space = int(($space+1023) / 1024);
	$space;
}

## ロギング
sub logging2 {
	my ($str) = @_;
	my $wday = ('日','月','火','水','木','金','土')[$wday];
	my $Str = "$year/$month/$mday($wday) $hour:$min\t$domain1\t$user1\t$ENV{'REMOTE_ADDR'}\t$str";
	Encode::_utf8_off($Str);
	
	if (open(MyFILE,">>$fsroot/logs/$year-$month.log")){
			flock(MyFILE,2);
			print MyFILE "$Str\n";
		close(MyFILE);
	}
}

## 改ページリンクを生成
sub page_split {
	my ($cgi,$page,@reg) = @_;		# スクリプト文字列、現ページ数、データ
	my ($item1,$key,$link);
	my $item = $k4fsitem;
	
	my $all = @reg;
	my $start = $item*$page;
	my $counter = $start+1;
	my @list = splice(@reg,$start,$item);
	
	if ($all > $item*($page+1)){
		$key = $page + 1;
		$counter .= '-'. $item*$key;
		if ($all < $item*($key+1)){ $item1 = "残りの". ($all - ($key*$item)) ."件";}
		else { $item1 = "次の".$item."件";}
		$link = "&nbsp;&nbsp;<a href='$cgi+$key+$key7'>$item1</a>$arrowR&nbsp;";
		if ($all > $item*($page+2)){
			$key = int($all/$item);
			if ($key*$item != $all){}
			else {$key--;}
			$link = "$link<a href='$cgi+$key+$key7'>末尾へ</a>$arrowR$arrowR&nbsp;";
		}
	} else {
		$counter .= '-'.$all if $counter != $all;
	}
	
	if ($page){
		$key = $page - 1;
		$link = "$arrowL<a href='$cgi+$key+$key7'>前の".$item."件</a>".$link;
		if ($page > 1){$link = "$arrowL$arrowL<a href='$cgi+0+$key7'>先頭へ</a>&nbsp;$link";}
	}
	
	if ($link){$link = "<div align='right'>$fs$link$fe</div>";}
	else {$link = '<br>';}
	
	($link,$counter,@list);
}

## ヘッダを表示
sub print_header1 {
	local ($error,$op1) = @_;		# $op1は検索フォームを付けないフラグ
	&htmlconv('title2','error');
	$error = "$alert $fs5R $error$fe" if $error;
	my $title = "ファイルの管理";
	
	my $str1 = <<"EOF";
$table1
<tr><td><form method='post' action='$searchcgi'></td>
<td nowrap>
<input type='hidden' name='key4' value='$key4'>
<input type='hidden' name='key5' value='$key5'>
<input type='hidden' name='key6' value='$key6'>
ファイル検索 <input name='keyword' size=15 maxlength=50>
<input type='submit' value='検索'></td><td></form></td></tr>
</table>
EOF
#	$str1 = '' if (!$fssearch || $op1);
	$str1 = '';
	
	print "Content-Type: text/html; charset=$charset\nPragma: no-cache\n\n";
	print "<html><head>$charcss<script type='text/javascript'><!--\nfunction SetChecked(val){";
	print "dml=document.mList;len=dml.elements.length;var i=0;for(i=0;i<len;i++){";
	print "if(dml.elements[i].name=='delx'){dml.elements[i].checked=val;}}}//--></script></head>";
	
	my $K4 = <<"EOF";
<body bgcolor='#ffffff' class='doc13' topmargin=1 leftmargin=4 marginheight=1 marginwidth=4 $cbody0>
$table0
<tr><td height=1><a name='top'>$null</a></td></tr>
<tr valign='bottom'><td><a href='$startcgi?0+0+0'>
<img src='$idir/folder2.gif' width=32 height=25 title='$title' border=0></a></td>
<td nowrap>&nbsp;$fs7G<b>$title</b>$fe&nbsp;&nbsp;</td>
<td width='100%'>$error</td><td>$str1</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#C0C0C0' colspan=4 height=1></td></tr>
<tr valign='top'><td height=12></td></tr>
</table>
EOF
	&print_utf($K4);
}

## フォルダ一覧/ヘルプを表示
sub print_header2 {
	my ($count1,$count2,$op1) = @_;		# op1があるときはサービストップ
	my ($folders,$name) = &get_dirs_list() if !$op1;
	my ($str1);
	if (!$name){
		$name = '利用状況';
		$str1 = '<br>';
	}
	1 while $count1 =~ s/(.*\d)(\d\d\d)/$1,$2/;
	1 while $count2 =~ s/(.*\d)(\d\d\d)/$1,$2/;
	$count1 = 0 if $count1 eq '';
	$count2 = 0 if $count2 eq '';
	
	if (!$op1){
		$count2 = ", ファイル: <b>$count2</b>";
		$folders = <<"EOF";
<tr><td align='center' bgcolor='#c0c0c0'><font color='white'><b>フォルダツリー</b></font></td></tr>
<tr><td height=4></td></tr>
$folders
EOF
	} else {
		$count2 = '';
		my $str = "$buttonG メールボックス内メッセージから添付ファイルを個人用フォルダに保存できます。<br>" if $fsattach;
		$folders = <<"EOF";
<tr><td>
$buttonG 個人用フォルダ内のファイルを管理します。<br>
<img src='$idir/null.gif' height=6 width=132 alt='' border=0><br>
$buttonG フォルダ名をクリックすればフォルダ内のサブフォルダやファイルの一覧を表示します。<br>
<img src='$idir/null.gif' height=6 width=132 alt='' border=0><br>
$str</td></tr>
EOF
	}
	
	my $K4 = <<"EOF";
$table0
<tr valign='top'><td>
	<table cellpadding=1 cellspacing=0 border=0>
	<tr><td bgcolor='#ffb0b0'>
		<table cellpadding=4 cellspacing=0 border=0 width='100%'>
		<tr valign='top'><td $bgcolor1 height=100>
			<table cellpadding=1 cellspacing=0 class='doc13' border=0>
			$folders
			</table></td></tr>
		</table></td></tr>
	</table></td>
<td><img src='$idir/null.gif' height=1 width=12 alt=''></td>
<td width='100%'>
	$table0
	<tr valign='bottom'><td>$str1
	<img src='$idir/arrow_blue.gif' width=32 height=13 title='$name'> 
	$fs7 $name $fe (フォルダ: <b>$count1</b>$count2)</td>
	<td align='right'></td></tr>
	<tr bgcolor='#c0c0c0'><td colspan=2 height=1></td></tr>
	<tr><td height=2></td></tr>
	</table>
EOF
	($K4,$name);
}

## ファイル/フォルダに対する処理内容を保存してリダイレクト
sub save_perms {
	my ($backcgi) = @_;		# $backcgiはもどり先スクリプト名
	
	if ($folder){$Task = 'folder';}
	elsif ($copy){$Task = 'copy';}
	elsif ($move){$Task = 'move';}
	elsif ($remove){$Task = 'remove';}
	elsif ($upload){$Task = 'upload';}
	else {$Task = 'rename';}
	
	my $taskid = time();
	open(FILE,">$tempdir/$loginid/.$taskid");
		print FILE <<"EOF";
key4 = $key4
key5 = $key5
key6 = $key6
key7 = $key7
key8 = $key8
key9 = $backcgi
Files = $Files
Folders = $Folders
Task = $Task
EOF
	close(FILE);
	
	# リダイレクト
	print "Location: $managecgi?$taskid\n\n";
	exit;
}

1;
