;### uK4 - グループの管理共通
use utf8;
$confirm2 = " onClick=\"if(!confirm('実行します。よろしいですか？')){return false;}\"";
$profile = 'profile.tab';
&auth();
exit if !$extstr4;

## メールアドレスを得る
sub get_email {
	my ($email) = @_;
	$email =~ s/\s*\(.+?\)\s*//g;
	$email =~ s/[^<]*<//g;
	$email =~ s/>.*//g;
	$email;
}

## 特定グループ全メンバーリストを得る(ただし、子グループはその直属メンバーのみ)
sub get_group_members {
	my ($group,$op) = @_;		# $opはuser.tab/config.tabから個人情報を得る場合
	my @members;
	my @users;
	
	# XMailユーザ一覧を読む
	foreach (&get_userlist()){
		s/<.*?>//g;
		$_ = lc($_);
		push(@users,$_);
	}
	
	# グループ内グループ直属メンバー
	foreach my $m (glob("$groot/$group/groups/*")){
		my $group = $& if $m =~ /[^\/]+$/;
		next if $group !~ /^\d{3}$/;
		my @tmp = &get_group_members2($group,$op,@users);
		push(@members,@tmp);
	}
	
	# グループ内ドメインメンバー
	foreach my $m (glob("$groot/$group/domains/*")){
		my $domain = $& if $m =~ /[^\/]+$/;
		$doamin =~ s/\./\\$&/g;
		foreach my $m2 (@users){
			if ($m2 =~ /\@$domain$/i){push(@members,$m2);}
		}
	}
	
	# 自グループ直属メンバー
	my @tmp = &get_group_members2($group,$op,@users);
	push(@members,@tmp);
	
	# 重複を除く
	my %count;
	@members = grep(!$count{$_}++, @members);
	
	@members;
}

## 特定グループ直属メンバーリストを得る
sub get_group_members2 {
	my ($group,$op,@users) = @_;	# @usersはXMailアカウント
	my @members;					# $opは詳細情報を得る
	
	foreach my $m (glob("$groot/$group/members/*")){
		my $name = $& if $m =~ /[^\/]+$/;
		$name = lc($name);
		my ($name2) = &mod_str($name);
		my ($line) = grep(/^$name2$/,@users);
		if (!$line){
			unlink($m);
			next;
		} elsif ($op){
			my %i = &get_private_info($name);
			foreach (qw(RealName HomePage Address Telephone MaxMBSize SmtpPerms ReceiveEnable PopEnable)){
				$line .= "\t" . $i{$_};
			}
		}
		push(@members,$line);
	}
	
	@members;
}

## グループアクセス権を得る
sub get_group_perms {
	my ($group) = @_;
	my $file = "$groot/$group/$groupadmintab";
	return() if !-f $file;
	
	my %p = &getenv($file,'=');
	%p;
}

## グループ情報を得る
sub get_group_profile {
	my ($group) = @_;
	my $file = "$groot/$group/$profile";
	return() if !-f $file;
	
	my %g = &getenv($file,'=');
	%g;
}

## 全ユーザリストを得る
sub get_userlist {
	my ($domain) = @_;
	my @tmp;
	my @tmp2;
	
	open(MyFILE,"$mailroot/mailusers.tab");
		@tmp = <MyFILE>;
	close(MyFILE);
	
	foreach(sort(@tmp)){
		chomp;
		s/"//g;
		if (/^\s*$/ || /"*M"*$/i || /^#/ || !/\t/){next;}
		my @tmp1 = split(/\t/,$_);
		if ($domain && $domain !~ /^$tmp1[0]$/i){next;}
		my $tmp = "$tmp1[1]\@$tmp1[0]";
		my ($tmp1) = &mod_str($tmp);
		if ($robot =~ /^$tmp1$/i){next;}
		push(@tmp2,"<option value=\"$tmp\">$tmp</option>");
	}
	
	@tmp2;
}

## ページヘッダを表示
sub header {
	my ($error) = @_;
	$error = "$alert $error" if $error;
	
	%g = &get_group_profile($gid);		# グループ情報を得る
	%p = &get_group_perms($gid);		# グループアクセス権を得る
	
	my $menu = "<a href='group_home.cgi?$gid'>トップ</a> | ";
	$menu .= "<a href='group_members.cgi?$gid'>メンバ-管理</a> | " if $p{'ManageMembers'};
	$menu .= "<a href='group_notify.cgi?$gid'>全員同報</a> | " if $p{'Sendmail1'};
	$menu .= "<a href='group_sendmail.cgi?$gid'>責任者連絡</a> | " if $p{'Sendmail2'};
	$menu .= "<a href='group_info.cgi?$gid'>お知らせ</a> | " if $p{'EditInfo'};
	$menu .= "<a href='group_menu.cgi?$gid'>追加メニュ-</a> | " if $p{'EditMenu'};
	$menu .= "<a href='group_book.cgi?$gid'>アドレス帳</a> | " if $p{'EditBook'};
	$menu .= "<a href='group_footer.cgi?$gid'>フッタ</a> | " if $p{'EditFooter'};
	$menu .= "<a href='group_url.cgi?$gid'>ログアウト先</a> | " if $p{'EditUrl'};
	$menu =~ s/ *\| *$//;
	
	print "Content-Type: text/html; charset=$charset\n";
	print "CacheControl: no-cache\nPragma: no-cache\nExpires: -1\n\n";
	print "<html><head>$charcss</head>";
	
	$K4 = <<"EOF";
<body $bodyp class='doc131' topmargin=2 leftmargin=4 marginheight=2 marginwidth=4 $cbody0>
$table0
<tr valign='bottom'><td>
<img src='$idir/group.gif' width=24 height=24 title='グループ [$g{'Name'}] の管理' border=0></td>
<td class='doc17' nowrap>&nbsp;[<b>$g{'Name'}</b>] の管理 &nbsp;</td>
<td class='doc15' width='100%'>$fs5R<b>$error</b></font></td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#C0C0C0' colspan=3 height=1></td></tr>
<tr><td height=2></td></tr>
<tr><td $bgcolor1 colspan=3 align='center'>$menu</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#C0C0C0' colspan=3 height=1></td></tr>
<tr><td height=10></td></tr>
</table>
EOF
	&print_utf($K4);
}

sub print_mytitle {
	my ($op) = @_;
	my ($str1,$str2);
	
	if ($op eq 'members'){
		$str1 = "メンバー管理";
		$str2 = "グループメンバーの閲覧、登録、削除";
	} elsif ($op eq 'notify'){
		$str1 = "全員同報";
		$str2 = "グループメンバー全員に対して同報メッセージを送信";
	} elsif ($op eq 'sendmail'){
		$str1 = "責任者連絡";
		$str2 = "グループ責任者に対してメッセージを送信";
	} elsif ($op eq 'info'){
		$str1 = "お知らせ";
		$str2 = "グループメンバーのログインで表示する管理者からのメッセージを編集";
	} elsif ($op eq 'menu'){
		$str1 = "追加メニュー";
		$str2 = "グループメンバーに対して追加表示する専用メニューを編集";
	} elsif ($op eq 'book'){
		$str1 = "アドレス帳";
		$str2 = "グループメンバーに対して追加表示するアドレス帳データを編集";
	} elsif ($op eq 'footer'){
		$str1 = "フッタ";
		$str2 = "グループメンバーがメッセージを送信するときに強制付加する定型文を編集";
	} elsif ($op eq 'url'){
		$str1 = "ログアウト先";
		$str2 = "グループメンバーがログアウトするときに開くウェブサイトを指定";
	}
	
	$K4 = <<"EOF";
$table0
<tr valign='bottom'><td class='doc15' nowrap><img src='$idir/arrow_blue.gif' width=32 height=13 title='$title1'>
<font $colorG><b>$str1</b></font>&nbsp;</td>
<td width='100%'>($str2)</td></tr>
<tr><td bgcolor='#c0c0c0' colspan=2></td></tr>
<tr><td height=8></td></tr>
</table>
EOF
	&print_utf($K4);
}

1;
