#!c:/usr/perl/bin/perl.exe

### uK4 - 予定表を表示する(個人用/ドメイン用/グループ用をまとめて表示)
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use Time::Local;
use utf8;
require './config.cgi';
$cgi1 = 'schedule1.cgi';
$cgi2 = 'schedule2.cgi';		# 記入用
$write = "<img src='../image/write.gif' width=18 height=16 border=0 title='この日の個人の予定を書く'>";
&auth;
&expire() if $Expired;

($cyear,$cmonth) = @ARGV;
$cyear = $year if (!$cyear || $cyear eq 'top');
$cmonth = $month if !$cmonth;

&html();

### ---------------------------------
sub html {
	print <<"EOF";
Content-Type: text/html; charset=$charset
CacheControl: no-cache
Pragma: no-cache
Expires: -1

<html><head>$charcss</head>
<body $bodyp class='doc131' topmargin=2 leftmargin=4 marginheight=2 marginwidth=4 $cbody0>
EOF
	
	$K4 = <<"EOF";
<table cellpadding=0 cellspacing=0 border=0 width='100%'>
<tr><td height=8></td></tr>
<tr><td nowrap width='100%'><img src='$idir/arrow_blue.gif' width=32 height=13 title='$title0'> 
$fs7G<b>$cyear/$cmonth の予定表</b>$fe</td></tr>
<tr><td bgcolor='#a0a0a0' colspan=4 height=1></td></tr>
<tr><td height=2></td></tr>
EOF
	
	# 前後1年の予定表を表示
	my $links;
	my ($xy,$xm) = ($cyear,$cmonth+6);
	if ($xm <= 12){$xy--;} else {$xm -= 13;}
	for (0 .. 11){
		my ($str1,$str2,$str3);
		$xm++;
		if ($xm == 13){$xm = 1; $xy++;}
		$str1 = sprintf("%02d",$xm);
		if ($cyear eq "$xy" && $cmonth eq "$str1"){
			$str2 = "<font color='red'><b>"; $str3 = '</b></font>';
		} else {
			$str2 = "<a href='$cgi1?$xy+$str1'>";
			$str3 = "</a>";
		}
		$links .= "$str2$xy/$str1$str3 | ";
	}
	$links =~ s/\|\s*$//;
	$K4 .= "<tr><td class='doc111'>$links</td></tr>\n";
	$K4 .= "<tr><td height=6></td></tr>\n</table>\n";
	
	&print_utf($K4);
	
	# 予定表を表示
	&print_schedule($cyear,$cmonth);
	
	# 備考
	$K4 = "<ul>";
	$K4 .= "<li>$write アイコンから個人用の予定を入力・更新することができます。</li>";
	if (-s "$mailroot/schedules/all/$cyear-$cmonth.tab" ||
		-s "$mailroot/schedules/domains/$domain1/$cyear-$cmonth.tab"){
		$K4 .= "<li>この予定表にはグループやドメインの予定が含まれる場合があります。<br>";
		$K4 .= "[A] はサイト全体の予定、[D] はドメインの予定、[G] はグループの予定です。</li>";
	}
	$K4 .= "</ul>";
	
	&print_utf($K4);
	&print_footer(1);
	exit;
}

## 予定表を表示
sub print_schedule {
	my ($cyear,$cmonth) = @_;
	my %month = ('01',31,'02',28,'03',31,'04',30,'05',31,'06',30,'07',31,'08',31,'09',30,'10',31,'11',30,'12',31);
	$month{'02'} = 29 if ($cyear%4 == 0 && ($cyear%400 == 0 || $cyear%100 != 0));	# 閏年の判定
	$ratio = int(100/7);
	my $width = "width='$ratio%'";
	local (@holiday,@specialday,%schedule);
	
	## $cyear/$cmonth/01が何曜日($wday)か決定
	my $time = timelocal(0,0,0,1,$cmonth-1,$cyear-1900);
	my $wday = (localtime($time))[6];
	$wday =~ tr/0123456/6012345/;
	
	## 休日データを得る(重要日、国民の休日)
	foreach my $h (qw(holiday specialday)){
		open(FILE,"$mailroot/schedules/$h.tab") || next;
			while (<FILE>){
				$_ = &dec_utf($_,$charsetE);
				chomp();
				push(@$h,$_);
			}
		close(FILE);
	}
	
	## 予定表データを得る(個人用/全体/グループ/ドメイン)
	my @files = (
		"domains/$domain1/$user1/schedules/$cyear-$cmonth.tab",
		"schedules/all/$cyear-$cmonth.tab",
		"schedules/domains/$domain1/$cyear-$cmonth.tab");
	foreach my $g (split(/_+/,$extstr3)){
		$g =~ s/^[A-Z]//i;
		push(@files,"schedules/groups/$g/$cyear-$cmonth.tab");
	}
	my %schedule;
	foreach my $file (@files){
		open(FILE,"$mailroot/$file") || next;
			while (<FILE>){
				$_ = &dec_utf($_,$charsetE);
				chomp;
				my ($key,$val) = split(/\t+/,$_);
				next if !$val;
				$val =~ s/\|\|/<br>/g;
				if ($file =~ /\/all\//){$schedule{$key} .= "[A] $val<br>";}
				elsif ($file =~ /\/domains\//){$schedule{$key} .= "[D] $val<br>";}
				elsif ($file =~ /\/groups\//){$schedule{$key} .= "[G] $val<br>";}
				else {$schedule{$key} .= "$val<br>";}
			}
		close(FILE);
	}
	
	## カレンダーを表示
	$K4 = <<"EOF";
<table cellpadding=1 cellspacing=0 border=0 width='100%'>
<tr bgcolor='#e0e0ff'><td>
	<table cellpadding=1 cellspacing=1 class='doc121' border=0 width='100%'>
	<tr align='center' bgcolor='#f0fff0'><td $width>月</td><td $width>火</td><td $width>水</td>
	<td $width>木</td><td $width>金</td><td $width><font color='#4040ff'>土</font></td>
	<td $width><font color='red'>日</font></td></tr>
EOF
	my ($go,$today,$today2);
	for my $r (0..5){
		$K4 .= "<tr bgcolor='#ffffff' height=100 valign='top'>";
		my $x;
		for my $c (0..6){
			my ($bgc,$data,$holiday,$specialday,$str,$str1,$str2);
			my $write2 = $write;
			$bgc = "bgcolor='#f0ffff'" if $c == 5;
			$bgc = "bgcolor='#fff0f0'" if $c == 6;
			if ($r == 0 && $c == $wday){
				$data = $schedule{'01'};
				$today++;
				$go = 1;
			} elsif ($go){
				my $str2 = sprintf("%02d",$today);
				$data = $schedule{$str2};
			} else {
				$data .= "";
			}
			$x = 1 if $month{$cmonth} == $today;
			my $title = "title='この日の個人の予定を記入します'";
			$write2 = '' if !$go;
			if ($cyear == $year && $cmonth == $month && $today == $mday){
				$bgc = "bgcolor='#ffffe0'";
				$str = "<font color='red'>(本日)</font>";
			}
			$str1 = sprintf("%02d",$today);
			($holiday) = grep(/$cmonth$str1/,@holiday);					# 国民の休日
			($specialday) = grep(/^$cyear$cmonth$str1/,@specialday);	# 重要日
			if ($holiday){
				$bgc = "bgcolor='#c0ffc0'";
				my ($d,$desc) = split(/\s+/,$holiday);
				if ($desc){
					$str2 .= ',' if $str2;
					$str2 .= $desc;
				}
			}
			if ($specialday){
				$bgc = "bgcolor='#ffc0c0'";
				my ($d,$desc) = split(/\s+/,$specialday);
				if ($desc){
					$str2 .= ',' if $str2;
					$str2 .= $desc;
				}
			}
			if ($month{$cmonth} >= $today){
				$K4 .= "<td $bgc><a href='$cgi2?$cyear+$cmonth+$today' $title><font color='#008000' size=4>";
				$K4 .= "<b>$today</b></font> $write2<font color='#4040ff'>$str2</font>$str</a><br>$data</td>";
				$today++ if $go;
			} else {
				$today2++;
				$K4 .= "<td bgcolor='#e0e0ff'><font color='#a0a0a0'><b>$today2</b></font></td>";
			}
		}
		$K4 .= "</tr>\n";
		last if $x;
	}
	
	$K4 .= <<"EOF";
	<tr align='center' bgcolor='#f0fff0'><td $width>月</td><td $width>火</td><td $width>水</td>
	<td $width>木</td><td $width>金</td><td $width><font color='#4040ff'>土</font></td>
	<td $width><font color='red'>日</font></td></tr>
	</table></td></tr>
</table>
EOF
	&print_utf($K4);
}
